from sqlalchemy import Column, Integer, String, DateTime, func, ForeignKey
from sqlalchemy.orm import relationship
from app import db
from sqlalchemy.ext.declarative import declarative_base

Base: declarative_base = db.Model
class Device(Base):
    __tablename__ = "devices"
    device_id = Column(Integer, primary_key=True)
    device_type_id = Column(Integer, nullable=False)
    user_id = Column(Integer, ForeignKey('users.id'))
    zone_id = Column(Integer, ForeignKey('zone.zone_id'))
    room_id = Column(Integer, ForeignKey('rooms.id'))
    site_id = Column(Integer, ForeignKey('sites.site_id'))
    device_name = Column(String, nullable=True)
    device_type_name = Column(String, nullable=False)
    device_mac_address = Column(String, nullable=False)
    x_coordinate = Column(String, nullable=False)
    y_coordinate = Column(String, nullable=False)
    created_at = Column(DateTime(timezone=True), default=func.now())
    updated_at = Column(DateTime(timezone=True), default=func.now())

    adv_frame_types = relationship("AdvFrameType", back_populates="device", cascade="all, delete-orphan")